var ryan=ryan||{};
ryan.interval=null;
(function (nameSpace) {
	Config={};
	Config.JsonPath="";
	Config.arrowOffsets={arrowcenter:{x:70,y:5,url:"assets/crossroad/arrowcenter.png"},arrowright:{x:119,y:26,url:"assets/crossroad/arrowright.png"},arrowleft:{x:10,y:26,url:"assets/crossroad/arrowleft.png"},width:142,height:111,bound:[0,0,560,373]};
	var preLoader={};
	var Event=function(){
		Event.RES_COMPLETE="RES_COMPLETE";
	};
	var RESLoader=function(){
		RESLoader.loaded=false;
		RESLoader.arrowObjects={arrowleft:null,arrowcenter:null,arrowright:null};
		return{
			loadData:function(){
				var that=this;
				var loaded=0;
				for(var i in Config.arrowOffsets){
					if(String(i).indexOf('arrow')==-1)break;
					var arrow=new Image();
					arrow.name=i;
					arrow.src=Config.arrowOffsets[i].url;
					(function(a){
						a.onload=function(){
							switch (a.name){
								case 'arrowcenter':
									RESLoader.arrowObjects["arrowcenter"]=a;
									break;
								case 'arrowleft':
									RESLoader.arrowObjects["arrowleft"]=a;
									break;
								case 'arrowright':
									RESLoader.arrowObjects["arrowright"]=a;
									break;
							}
							loaded++;
							if(loaded>=3){
								var event=document.createEvent('Event');
								event.initEvent(Event.RES_COMPLETE, false, false);
								roadCross.canvas.dispatchEvent(event);
							}
						}
					})(arrow)

				}
			}
		}
	};
	var roadCross=function(){
		roadCross.canvas=null;
		var _context;
		var origin= {x: 0, y: 0, w: 0, h: 0, iw:0,ih:0,percent: 0};
		var stageW=0;
		var stageH=0;
		var sourceImg={width:0,height:0};
		var _json;
		function getArrowNameforHeading(heading){
			var names={"90":Math.PI/2,"0":0,"270":-Math.PI/2};
			return names[heading];
		}
		function getDirection(angle) {
			if ((angle >= 315 && angle < 360) || (angle >= 0 && angle < 45)) {
				return 0;
			}
			else if (angle >= 45 && angle < 135) {
				return 90;
			}
			else if (angle >= 135 && angle < 225) {
				return 180;
			}
			else {
				return 270;
			}
		}
		function insertionSort(myArray) {
			var len = myArray.length,
				value,
				i,
				j;
			for (i=0; i < len; i++) {
				value = myArray[i];
				for (j=i-1; j > -1 && myArray[j] > value; j--) {
					myArray[j+1] = myArray[j];
				}
				myArray[j+1] = value;
			}
			return myArray;
		}
		return{
			clear:function(){
				if(_context)_context.clearRect(0,0,roadCross.canvas.width,roadCross.canvas.height);
			},
			preLoad:function(json,floorName){//预加载机制
				if(json===null) return;
					var obj=json.CrossImageResult;
				for(var i=0;i<obj.length;i++){
					if(obj&&obj[i]&&obj[i].Result){
						var ids=obj[i].Result;
						for(var j=0;j<ids.length;j++){
							id=ids[j].Connectionid;
							if(typeof preLoader[id]=="string")continue;
							var url=mapconfig.crossRoad.imgUrl+config.get("bdid")+"/data"+(obj[i].floor).split("F")[1]+"/image/"+id+".jpg";
							var img = new Image();
							img.src = url;
							img.onerror=function(){};
								(function(i){
									i.onload=function(){
										//console.log("iiiiiiok:",i.src)
									}
								})(img);
							preLoader[id]=url;
						}
					}
				}

			},
			init:function(canvas,window){
				roadCross.canvas=canvas;
				_context=canvas.getContext("2d");
				canvas.style.width=window.innerWidth+"px";
				canvas.width=window.innerWidth;
				canvas.style.height=window.innerHeight+"px";
				canvas.height=window.innerHeight;
				stageW=window.innerWidth;
				stageH=window.innerHeight;
			},
			setImageStyle:function(bgImage){
				var h = parseInt(stageH * (50 / 100));
				var w = parseInt(bgImage.width * (h / bgImage.height));
				origin.x = parseInt(-(w - stageW) / 2);
				origin.percent = w / bgImage.width;
				origin.w = w;
				origin.h = h;
				origin.iw = bgImage.width;
				origin.ih = bgImage.height;
			},
			loadImage:function(json){
				//console.log(JSON.stringify(json));
				_json={};
				if(!json.ArrowGroup||json.ArrowGroup.length<=0){
					console.log( "ArrowGroup为空,这里不应该显示!")
					return;
				}
				var arrowGroup=json.ArrowGroup[0];
				var doorGroup=(function(){
					for(var i=0;i<json.DoorGroup.length;i++){
						if(json.DoorGroup[i].doorID==arrowGroup.doorId){
							return json.DoorGroup[i];
						}
					}
					return [];
				})();
				_json.doorPath=doorGroup.doorPath;
				_json.arrowAngle=arrowGroup.arrowAngle;
				_json.arrowPath=arrowGroup.arrowPath;
				sourceImg.width=json.ImgWidth;
				sourceImg.height=json.ImgHeight;

				Config.JsonPath = mapconfig.crossRoad.jsonUrl+"/data"+(json.floorName).split("F")[1] + "/connectionid/";
				var url=mapconfig.crossRoad.imgUrl+config.get("bdid")+"/data"+(json.floorName).split("F")[1]+"/image/"+json.Connectionid+".jpg"
				var that=this;
				var image = new Image();
				image.src = url;
				image.onload = function () {
					that.setImageStyle(image);
					//door glitter
					var strokeStyle=["rgba(255,255,255,0)","rgba(244,161,0,0.5)"],i=0;
					that.drawImage(image,strokeStyle[i]);
					nameSpace.interval=setInterval(function(){
						that.drawImage(image,strokeStyle[i++%2]);
					},500);
				}
			},
			drawImage:function(image,strokeStyle){
				if(!_context) throw "没有设置canvas";
				_context.fillStyle = "#EEEEFF";
				var that=this;
				var sx=0;//图像上的x坐标
				var sy=0;//图像上的y坐标
				var sw=image.width;//矩形区域的宽度
				var sh=image.height;//矩形区域的高度
				var dx=origin.x;//画在canvas的x坐标
				var dy=origin.y;//画在canvas的y坐标
				var dw=origin.w;//画出来的宽度
				var dh=origin.h;//画出来的高度
				//console.log(origin.w,origin.h,origin.iw,origin.ih,stageW,stageH/2,origin.percent);
				_context.clearRect(0,0,roadCross.canvas.width,roadCross.canvas.height);
				_context.fillStyle = 'black';
				_context.fillRect(0,0,stageW,stageH/2);
				_context.drawImage(image,sx,sy,sw,sh,dx,0,dw,dh);
				that.createDoorLine(_json,strokeStyle,that);

			},
			createDoorLine:function(obj,strokeStyle,that){
				ctx.restore();
				if(!obj.doorPath||obj.doorPath.length<=0)return;
				var points=obj.doorPath;
				var startPoint={};
				_context.fillStyle="rgba(255,255,255,0.5)";
				_context.strokeStyle=strokeStyle;
				_context.lineJoin="round";
				_context.lineWidth=3;
				_context.beginPath();
				var tempFirst={x:0,y:0};
				var arrX=[],arrY=[];
				for(var i=0;i<points.length;i++){
					var _obj={};
					_obj.x=points[i].x*(origin.w/sourceImg.width)+origin.x;
					_obj.y=points[i].y*(origin.h/sourceImg.height);
					arrX[i]=_obj.x;
					arrY[i]=_obj.y;
					if(i==0){
						//tempFirst=_obj;
						_context.moveTo(_obj.x,_obj.y);
						startPoint={x:_obj.x,y:_obj.y}
					}else{
						_context.lineTo(_obj.x,_obj.y);
					}
				}
				//_context.lineTo(tempFirst.x,tempFirst.y);
				_context.fill();
				_context.stroke();
				_context.save();

				var tempX=insertionSort(arrX);
				var tempY=insertionSort(arrY);
				that.createArrowLine(_json,tempX[0],tempX[tempX.length-1],tempY[arrY.length-1]+20);
				return {};
			},
			createArrowLine:function(obj,minX,maxX,maxY){
				var centerX=roadCross.canvas.width/2;
				var centerY=roadCross.canvas.height/2-100;
				//var heading=getArrowNameforHeading(obj.arrowAngle);
				var arrows=[],head=[];
				if(obj.arrowAngle==0){
					head=[[0,0],[-20,50],[20,50]];
					arrows=[[-10,50],[10,50],[10,150],[-10,150]];
					centerX=roadCross.canvas.width/2;
					centerY=maxY;
				}else if(obj.arrowAngle==90){
					head=[[0,60],[30,40],[30,80]];
					arrows=[[30,50],[80,50],[80,150],[60,150],[60,70],[30,70]];
					centerX=minX;
					centerY=maxY-80;
				}else{
					head=[[0,60],[-30,40],[-30,80]];
					arrows=[[-30,50],[-80,50],[-80,150],[-60,150],[-60,70],[-30,70]];
					centerX=maxX;
					centerY=maxY-80;
				}
				transformTo3D(_context,roadCross.canvas.width,roadCross.canvas.height,centerX,centerY);
				nameSpace.drawArrow(arrows,head,"rgba(244,161,0,0.5)",_context,false);
				return {};
			}
		}
	};
	nameSpace.drawRoadCross=new roadCross();
})(ryan||{});
//电梯动画 cheng.li 20150724
(function(){
	var Config={};
	//Config.stairsOffsets={
	//	"futi":{"down":"assets/crossroad/stairs/futi_down.jpg","up":"assets/crossroad/stairs/futi_up.jpg","down_out":"assets/crossroad/stairs/futi_out.jpg","up_out":"assets/crossroad/stairs/futi_out.jpg"},
	//	"zhiti":{"down":"assets/crossroad/stairs/zhiti_down.jpg","up":"assets/crossroad/stairs/zhiti_up.jpg","down_out":"assets/crossroad/stairs/zhiti_down_out.jpg","up_out":"assets/crossroad/stairs/zhiti_up_out.jpg"},
	//	"louti":{"down":"assets/crossroad/stairs/louti_down.jpg","up":"assets/crossroad/stairs/louti_up.jpg","down_out":"assets/crossroad/stairs/louti_out.jpg","up_out":"assets/crossroad/stairs/louti_out.jpg"}
	//};
	Config.stairsOffsets={"futi":"assets/crossroad/stairs/futi.jpg",
		"zhiti_up":"assets/crossroad/stairs/zhiti_up.jpg",
		"zhiti_down":"assets/crossroad/stairs/zhiti_down.jpg",
		"louti":"assets/crossroad/stairs/louti.jpg"};

	var $floorInfo=$("#floorInfo"),
		$stairs_container=$("#stairs_container");
		$img=$stairs_container.find("img"),
		canvas=$stairs_container.find("canvas")[0],
		ctx=canvas.getContext('2d'),
		arrows=[],
		head=[],
		winHeight=window.innerHeight,
		winWidth=window.innerWidth,
		txt=null,
		offset=[0,0],
		changeIndex=[],
		centerX=canvas.width/2,
		centerY=canvas.height/2;
	$(canvas)['attr']("height",screenPixel(winHeight));
	$(canvas)['attr']("width",screenPixel(winWidth));
	var floors=config.get("floorsInfo");
	//hospital3D.page.mapView.drawStairs({"currFloor":"3","type":"futi","direction":"up"})
	ryan.drawStairs=function(params){
		console.log(JSON.stringify(params));
		var currFloor=params['currFloor'],
			type=params['type'],
			direction=params['direction'];
		if(changeIndex[0]==currFloor+type+direction){
			return;
		}else{
			changeIndex[0]=currFloor+type+direction;
		}
		console.log(Config.stairsOffsets[type]);
		//$img.attr("src",Config.stairsOffsets[type][direction]);
		if((type+"_"+direction).indexOf("zhiti_up")==0){
			$img['attr']("src",Config.stairsOffsets["zhiti_up"]);
		}else if((type+"_"+direction).indexOf("zhiti_down")==0){
			$img['attr']("src",Config.stairsOffsets["zhiti_down"]);
		}else{
			$img['attr']("src",Config.stairsOffsets[type]);
		}
		switch(type+"_"+direction){
			case "futi_down":
				head=[[100,-50],[70,0],[130,0]];
				arrows=[[-20,0],[20,0],[20,60],[80,60],[80,0],[120,0],[120,100],[-20,100]];
				txt="下扶梯";
				offset=[55,80];
				centerX=canvas.width/2+100;
				centerY=canvas.height-200;
				break;
			case "futi_up":
				head=[[0,-50],[-30,0],[30,0]];
				arrows=[[-20,0],[20,0],[20,60],[80,60],[80,0],[120,0],[120,100],[-20,100]];
				txt="上扶梯";
				offset=[55,80];
				centerX=canvas.width/2+100;
				centerY=canvas.height-200;
				break;
			case "futi_down_out":
				head=[[0,80],[-30,30],[30,30]];
				arrows=[[-20,-80],[20,-80],[20,30],[-20,30]];
				txt="出,扶,梯";
				offset=[8,-25];
				centerX=canvas.width/2+100;
				centerY=canvas.height-200;
				break;
			case "futi_up_out":
				head=[[0,80],[-30,30],[30,30]];
				arrows=[[-20,-80],[20,-80],[20,30],[-20,30]];
				txt="出,扶,梯";
				offset=[8,-25];
				centerX=canvas.width/2+100;
				centerY=canvas.height-200;
				break;
			case "zhiti_down":
				break;
			case "zhiti_up":
				break;
			case "zhiti_down_out":
				head=[[0,80],[-30,30],[30,30]];
				arrows=[[-20,-80],[20,-80],[20,30],[-20,30]];
				txt="出,电,梯";
				offset=[8,-25];
				centerX=canvas.width/2;
				centerY=canvas.height-150;
				break;
			case "zhiti_up_out":
				head=[[0,80],[-30,30],[30,30]];
				arrows=[[-20,-80],[20,-80],[20,30],[-20,30]];
				txt="出,电,梯";
				offset=[8,-25];
				centerX=canvas.width/2;
				centerY=canvas.height-150;
				break;
			case "louti_down":
				head=[[0,-50],[-30,0],[30,0]];
				arrows=[[-20,0],[20,0],[20,60],[80,60],[80,0],[120,0],[120,100],[-20,100]];
				centerX=canvas.width/2+100;
				centerY=canvas.height-200;
				txt="下楼梯";
				offset=[55,80];
				break;
			case "louti_up":
				head=[[100,-50],[70,0],[130,0]];
				arrows=[[-20,0],[20,0],[20,60],[80,60],[80,0],[120,0],[120,100],[-20,100]];
				centerX=canvas.width/2+100;
				centerY=canvas.height-200;
				txt="上楼梯";
				offset=[55,80];
				break;
			case "louti_down_out":
				//head=[[-70,80],[-20,50],[-20,110]];
				//arrows=[[-20,60],[80,60],[80,0],[120,0],[120,100],[-20,100]];
				//centerX=canvas.width/2+100;
				//centerY=canvas.height-250;
				//txt="出,楼,梯";
				//offset=[50,80];
				head=[[0,80],[-30,30],[30,30]];
				arrows=[[-20,-80],[20,-80],[20,30],[-20,30]];
				txt="出,楼,梯";
				offset=[8,-25];
				centerX=canvas.width/2;
				centerY=canvas.height-150;
				break;
			case "louti_up_out":
				head=[[-70,80],[-20,50],[-20,110]];
				arrows=[[-20,60],[80,60],[80,0],[120,0],[120,100],[-20,100]];
				centerX=canvas.width/2+100;
				centerY=canvas.height-250;
				txt="出楼梯";
				offset=[50,80];
				break;
		}
		transformTo3D(ctx,canvas.width,canvas.height,centerX,centerY);

		ryan.drawArrow(arrows,head,"rgba(47,198,181,0.5)",ctx,true);
		pageFloor(+currFloor);

	};
	ryan.drawArrow=function(arrows,head,fillStyle,context,b){
		if(!!b){
			if(arrows.length==0){
				blank();
				return;
			}else{
				blank();
			}
		}else{
			txt=null;
		}
		context.save();
		context.beginPath();
		context.fillStyle = fillStyle;
		context.strokeStyle = fillStyle;
		context.lineWidth=2;
		var startX=arrows[0][0] ,startY=arrows[0][1] ;
		context.moveTo3D(screenPixel(startX),screenPixel(startY));
		for(var i=0;i<arrows.length;i++){
			context.lineTo3D(screenPixel(arrows[i][0]) ,screenPixel(arrows[i][1]) );
		}
		context.lineTo3D(screenPixel(startX),screenPixel(startY));
		context.fill();
		//context.stroke();
		context.beginPath();
		context.lineWidth=2;
		context.moveTo3D(screenPixel(head[0][0]),screenPixel(head[0][1]));
		context.lineTo3D(screenPixel(head[1][0]),screenPixel(head[1][1]));
		context.lineTo3D(screenPixel(head[2][0]),screenPixel(head[2][1]));
		context.closePath();
		context.fill();
		//context.stroke();
		if(txt!=null){
			context.beginPath();
			context.font = "40px sans-serif";
			context.textBaseline = 'middle';
			context.fillStyle ='#fff';
			var text=txt.split(",");
			for(var k in text){
				context.fillText3D(text[k],screenPixel(offset[0]),screenPixel(offset[1])+(70)*k);
			}
			txt=null;
		}
		context.restore();
	};
	blank=function(){
		$floorInfo["html"]("");
		arrows=[];
		head=[];
		ctx.clearRect(0,0,canvas.width,canvas.height);

	};
	function screenPixel(pixel){
		return pixel*2;//window.devicePixelRatio;
	}
	function pageFloor(currFloor){
		var cFloor=currFloor;
		if(cFloor==0){
			$floorInfo.append("<span>"+floors[cFloor]['fl_namecode']+"</span>");
			$floorInfo.append("<span>"+floors[cFloor+1]['fl_namecode']+"</span>");
//			$floorInfo.append("<span>"+floors[cFloor+2]['fl_namecode']+"</span>");
		}else if(cFloor==floors.length-1){
//			$floorInfo.append("<span>"+floors[cFloor-2]['fl_namecode']+"</span>");
			$floorInfo.append("<span>"+floors[cFloor-1]['fl_namecode']+"</span>");
			$floorInfo.append("<span>"+floors[cFloor]['fl_namecode']+"</span>");
		}else{
			$floorInfo.append("<span>"+floors[cFloor-1]['fl_namecode']+"</span>");
			$floorInfo.append("<span>"+floors[cFloor]['fl_namecode']+"</span>");
			$floorInfo.append("<span>"+floors[cFloor+1]['fl_namecode']+"</span>");
		}
		var spanFloors=$floorInfo.find("span");
		spanFloors.removeClass("currFloor");
		for(var f in spanFloors){
			var tempFloor=$(spanFloors[f]);
			if(tempFloor.text()=="F"+(currFloor+1)){
				tempFloor.addClass("currFloor");
				break;
			}
		}
		$floorInfo["css"]("right",(window.innerWidth-$floorInfo.width())/2);
	}
})(ryan,Zepto);
function transformTo3D(ctx,canvasWidth,canvasHeight,offsetX,offsetY){
	var outputVec = [0,0,0];
	var viewMat = Matrix.create();
	Matrix.lookatRH(viewMat, [0, 500, 115], [0,0,0], [0,0,1]);
	var projMat = Matrix.create();
	Matrix.perspectiveRH(projMat, Math.PI/3, 1, 0.001, 1000);
	Matrix.multiply(projMat, viewMat, projMat);
	function transformCoord(outVec, inVec, mat){
		Matrix.transformCoord(outVec, inVec, mat);
		outVec[0] = (outVec[0] + 1) * 0.5 * canvasWidth-canvasWidth/2+offsetX;//中心点转为2D规则
		outVec[1] = (1 - outVec[1]) * 0.5 * canvasHeight-canvasHeight/2+offsetY;
		return outVec;
	}
	ctx.moveTo3D=function(x,y){
		transformCoord(outputVec, [x,y,0], projMat);
		ctx.moveTo(outputVec[0],outputVec[1]);
	};
	ctx.lineTo3D=function(x,y){
		transformCoord(outputVec, [x,y,0], projMat);
		ctx.lineTo(outputVec[0],outputVec[1]);
	};
	ctx.fillText3D=function(text,x,y){
		transformCoord(outputVec, [x,y,0], projMat);
		ctx.fillText(text,outputVec[0],outputVec[1]);
	};
}