﻿var mapconfig = {  //
	bdid :"B000A11DA1",
	poiData:window["poi_data"],
    zMin: 15,//最小级别
    zMax: 22,//最大级别
    zoom: 20,//初始级别
    aov:{heading:0,pitch:90},
    title:"北京协和医院",
    bdName:"北京协和医院",
    correctDistance:10,   //导航中多少米内进行纠偏
    restartRoute:20,      //导航中偏离多少米后开始重新规划
    loadDir:-1,//默认-1渲染2.5D;1渲染矢量;2同时渲染 cheng.li
    vectorUrl:"assets/mapconfig/B000A11DA1/data.json",//cheng.li
    version:"510",//用于更新缓存的版本,修改数据后要更换版本号 cheng.li

	crossRoad:{
		hasCross:true,//此楼是否支持路口放大图，false为不支持
		crossRoadUrl:"http://182.254.156.91/AnGeoCrossImageServer/B0FFFZYKC2/",//路口放大图请求服务
		imgUrl:"../../roadcross",//路口放大图图片目录
		jsonUrl:"../../roadcross"//路口放大图信息目录
	},
	
	//正式环境配置
	tileUrl:"http://182.254.156.91/angeomapdata/Beijing/xiehe_hos",
	routeUrl:"http://182.254.156.91/path/indoorroute",
	//panoUrl:"http://182.254.156.91/pano_server/panoserver.php",
        //panoParam:"yinchuan/cg",
	searchUrl:"http://182.254.156.91:8080/search-querier/search",
	
	center:{lon:116.41590194, lat: 39.91348416},
	dragExtent:[116.41426305, 39.91398277, 116.417520277, 39.912988055],   //left, top, right, bottom

	//center:{lon:116.39391973614693, lat: 39.885844563577436},
	//dragExtent:[116.3936, 39.88613, 116.3942, 39.88518],   //left, top, right, bottom

	mapTileExtent:[],
	startPosition:{
		poiName:'东四门',
		lon:116.41724972,
		lat:39.9132411,
        address: "一层东区",
		floorName:'F1'
	},
	initFloor:{
		layerName: "161110110100002"
	},
	floorsData:{
		"F1":{
			layerName:"161110110100002",
			lon:116.41590194,
			lat:39.91348416
		},
		//"F2":{
		//	layerName:"161110110200003",
		//	lon:116.416996,
		//	lat:39.913529
		//},
		"B1":{
			layerName:"161110100100210",
			lon:116.41589166,
			lat:39.9134852
		},
		"B2":{
			layerName:"161110100200211",
			lon:116.41588194,
			lat:39.9134852
		},
		"B3":{
			layerName:"161110100300217",
			lon:116.4158886,
			lat:39.91348527
		}
	},
	floorNames: {
		"161110110100002":"F1",
		//"161110110200003":"F2",
		"161110100100210":"B1",
		"161110100200211":"B2",
		"161110100300217":"B3"
	},
	floorCnNames: {
		"F1":"一层",
		//"F2":"二层",
		"B1":"负一",
		"B2":"负二",
		"B3":"负三"
	},
	floorExtent: {
		"161110110100002":[116.41426305, 39.91398277, 116.417520277, 39.912988055],
		//"161110110200003":[116.41426305, 39.91398277, 116.417520277, 39.912988055],
		"161110100100210":[116.41426305, 39.91398277, 116.417520277, 39.912988055],
		"161110100200211":[116.41426305, 39.91398277, 116.417520277, 39.912988055],
		"161110100300217":[116.41426305, 39.91398277, 116.417520277, 39.912988055]},
	floorsInfo: [
		{"fl_namecode":"F1","roomIDs":["综合服务台","建卡/挂号/收费","外科","检验结果查询","建大病历","自助服务区","药房","门诊接待室"]},
		{"fl_namecode":"B1","roomIDs":["综合服务台","建卡/挂号/收费","外科","检验结果查询","建大病历","自助服务区","药房","门诊接待室"]},
		{"fl_namecode":"B2","roomIDs":["综合服务台","建卡/挂号/收费","外科","检验结果查询","建大病历","自助服务区","药房","门诊接待室"]},
		{"fl_namecode":"B3","roomIDs":["综合服务台","建卡/挂号/收费","外科","检验结果查询","建大病历","自助服务区","药房","门诊接待室"]}
		//{"fl_namecode":"F2","roomIDs":["内科","内科检查区","内科化验室","中心治疗室","门诊化疗室","肿瘤化疗日间病房"]}
	],
/*	searchData: {
		"1":{"keyword":"洗手间","faceword":"厕所","type":"1"},
		"2":{"keyword":"挂号","faceword":"挂号","type":"1"},
		"3":{"keyword":"超声","faceword":"超声","type":"2","result":["54990210803313","54990210702860"]},
		"4":{"keyword":"放射","faceword":"放射","type":"2","result":["54990210303380"]},
		"5":{"keyword":"抽血","faceword":"抽血","type":"2","result":["54990210203347"]},
		"6":{"keyword":"药房","faceword":"药房","type":"2","result":["54990210100309","54990210100004","54990210103595","54990210103339"]}
	},*/
    colorClass:{//cheng.li
        "c00":{"a":{},"c":"#E0DFDC"},
        "c1":{"a":{},"c":"#A2B6D5"},
        "c2":{"a":{},"c":"#7AD2E5"},
        "c3":{"a":{},"c":"#CCD988"},
        "c4":{"a":{},"c":"#4DBD6E"},
        "c5":{"a":{},"c":"#E7AB7D"},
        "c6":{"a":{},"c":"#E0DFDC"},
        "c7":{"a":{},"c":"#F58220"}
    },
	/**
	 * 常用模块中推荐POI的配置
	 * name：显示名称，icon：图标，type：类型，不同的类型对应不同的点击动作，poiId：POI的id，keyword：搜索关键字，result：可配置的搜索结果，info：点击后的提示信息
	 * type为0时，点击后进入地图页面
	 * type为1时，点击后进入搜索结果页面，搜索结果来源于搜索服务
	 * type为2时，点击后进入搜索结果页面，搜索结果来源于配置
	 * type为3时，点击后出现操作提示
	 */
	commonPois: [
		{"name":"挂号","icon":"icon-guahao","type":"1","keyword":"挂号"},
		{"name":"缴费","icon":"icon-pay","type":"1","keyword":"收费"},
		{"name":"取药","icon":"icon-yao","type":"1","keyword":"取药处"},
		{"name":"服务台","icon":"icon-fenzhentai","type":"1","keyword":"服务台"},
		{"name":"抽血","icon":"icon-blood","type":"1","keyword":"采血处"},
		{"name":"取报告","icon":"icon-report","type":"1","keyword":"检查结果查询"},
		{"name":"卫生间","icon":"icon-cesuo","type":"1","keyword":"洗手间"},
		{"name":"电梯","icon":"icon-zhiti","type":"1","keyword":"客梯"}
	],
	/**
	 * 常用模块中所有POI分类的配置
	 * title：标题，icon：标题旁边的图标，list：poi或者子类型列表
	 * name：显示名称，type：类型，不同的类型对应不同的点击动作，poiId：POI的id，keyword：搜索关键字，result：可配置的搜索结果，info：点击后的提示信息
	 * type为0时，点击后进入地图页面
	 * type为1时，点击后进入搜索结果页面，搜索结果来源于搜索服务
	 * type为2时，点击后进入搜索结果页面，搜索结果来源于配置
	 * type为3时，点击后出现操作提示
	 */
	poiTypeList: [
		{"title":"出入口","icon":"icon-entrance","list":[
			{"name":"东一门","type":"0","poiId":"161110310110157"},
			{"name":"东二门","type":"0","poiId":"161110310110044"},
			{"name":"东三门","type":"0","poiId":"161110310110043"},
			{"name":"东四门","type":"0","poiId":"161110310110001"},
			{"name":"东五门","type":"0","poiId":"161110310110159"},
			{"name":"西一门","type":"0","poiId":"161110310110161"},
			{"name":"西二门","type":"0","poiId":"161110310110163"},
	        {"name":"西三门","type":"0","poiId":"161110310110164"},
			{"name":"南一门","type":"0","poiId":"161110310110045"},
			{"name":"南四门","type":"0","poiId":"161110310110160"},
			{"name":"南二门","type":"0","poiId":"161110310110158"},
			{"name":"南三门","type":"0","poiId":"161110310110176"},
			{"name":"北一门","type":"0","poiId":"161110310110156"},
			{"name":"北二门","type":"0","poiId":"161110310110046"},
			{"name":"北三门","type":"0","poiId":"161110310110165"},
			]},
		{"title":"去咨询","icon":"icon-help","list":[
			{"name":"服务台","type":"1","keyword":"服务台","poiId":"161110410100070"}
			]},
		{"title":"去建卡","icon":"icon-jianka","list":[
			{"name":"建卡","type":"1","keyword":"卡","result":["161110210100007","161110210200186"]}
		]},
		{"title":"去挂号","icon":"icon-guahao","list":[
			{"name":"挂号","type":"1","keyword":"挂号","result":["161110210200186","161110410100025","161110210100007","161110210200186"]}
			]},	
		{"title":"去缴费","icon":"icon-pay","list":[
			{"name":"缴费","type":"1","keyword":"收费","result":["54990210100232","54990210100304","54990210203352","54990210203354","54990210301447","54990210303377","54990210401817","54990210403394","54990210503404","54990210602696","54990210603413","54990210702896","54990210703420","54990210803121"]}
		]},
		{"title":"去取药","icon":"icon-yao","list":[
			{"name":"取药","type":"1","keyword":"取药处"}
		]},
		{"title":"去内科","icon":"icon-neike","list":[
			{"name":"输液室","type":"0","poiId":"161110210100736"}
			]},
		{"title":"去外科","icon":"icon-waike","list":[
			{"name":"膀胱镜检查室","type":"0","poiId":"161110210100061"},
			{"name":"尿动力检查室","type":"0","poiId":"161110210100063"},
			{"name":"脊椎动力平衡诊疗区","type":"0","poiId":"161110210100069"},
			{"name":"传染科","type":"0","poiId":"161110210100074"},
			{"name":"体外碎石室","type":"0","poiId":"161110210100276"}
		]},
		{"title":"去检查","icon":"icon-fang","list":[
			{"name":"检查室","type":"0","poiId":"161110210100031"},
			{"name":"内镜","type":"0","poiId":"54990210503403"}
			]},
		{"title":"去化验","icon":"icon-huayan","list":[
			{"name":"化验检查室","type":"0","poiId":"161110210100442"},
			{"name":"心电图检查","type":"0","poiId":"161110210100706"}
		]},
		{"title":"取报告","icon":"icon-report","list":[
			{"name":"取化验报告","type":"1","keyword":"检查结果查询"}
			]},
		{"title":"去治疗","icon":"icon-zhiliao ","list":[
			{"name":"输液","type":"1","keyword":"输液室"}
			]},
		{"title":"去卫生间","icon":"icon-cesuo","list":[
			{"name":"男卫生间","type":"1","keyword":"男洗手间"},
			{"name":"女卫生间","type":"1","keyword":"女洗手间"},
			{"name":"无障碍卫生间","type":"1","keyword":"残障洗手间"}
			]},
		{"title":"换楼层","icon":"icon-floor","list":[
			{"name":"电梯","type":"1","keyword":"客梯"},
			{"name":"扶梯","type":"1","keyword":"扶梯"},
			{"name":"楼梯","type":"1","keyword":"楼梯"}
			]},
		{"title":"辅助设备","icon":"icon-fuzhusheshi","list":[
			{"name":"自助挂号","type":"1","keyword":"自助挂号"},
			{"name":"自动售本机","type":"1","keyword":"自动售本机"},
			{"name":"自助报到机","type":"1","keyword":"自助报到机"},
			{"name":"医保终端机","type":"0","poiId":"161110410100020"},
			{"name":"处方打印机","type":"1","keyword":"处方打印机"},			
			{"name":"移动终端充电站","type":"1","keyword":"移动终端充电站"},
			{"name":"ATM","type":"0","poiId":"161110410100029"},
			{"name":"饮水处","type":"0","poiId":"161110410100071"},
			{"name":"休息区","type":"1","keyword":"休息区"}
			]}
	]
};