/**
 * Created by yanlong.yang on 2015/5/5.
 */
var strLength=function(str){
    var totalCount = 0;
    for(var i=0; i<str.length; i++){
        if(!str.charAt(i).match(/[u0391-uFFE5]/)) {
            if(str.charAt(i)==="("||str.charAt(i)===")"){
                totalCount++;
            }else{
                totalCount += 2;
            }
        } else {
            totalCount++;
        }
    }
    return totalCount;
}
Handlebars.registerHelper("text_list",function(items,options){
    var start="<ul>";
    var end="</ul>";
    var str="",poi="",keyword="",style="";
    for(var i= 0,l=items.length;i<l;i++){
        var item=items[i];
        if(i%4===0){
            if(i!==0){
                str+=end;
            }
            str+=start;
        }
        poi=item.poiId||item.result||"";
        keyword=item.keyword||item.info||"";
        style="";
        var length=strLength(items[i].name);
       if(items[i].name&&length>12) {
           style = "style='font-size:10px '";
       }
            str+="<li data-keyword='"+keyword+"' data-poi='"+poi+"' data-type='"+item.type+"'  data-value='"+item.name+"' "+style+">"+item.name+"</li>";

    }
    return str+end;
});

Handlebars.registerHelper("icon_list",function(items,options){
    var start="<ul class='main-icon-list'>";
    var end="</ul>";
    var str="",poi="",keyword="";

    for(var i= 0,l=items.length;i<l;i++){
        var item=items[i];
        if(i%4===0){
            if(i!==0){
                str+=end;
            }
            str+=start;
        }
        poi=item.result||"";
        keyword=item.keyword||"";
            str+="<li data-keyword='"+keyword+"' data-poi='"+poi+"' data-type='"+item.type+"' data-value='"+item.name+"' class='"+item.icon+"'>"+item.name+"</li>";
    }
    return str+end;
});

Handlebars.registerHelper("autocomplete_list",function(items,options){
    var start="<ul class='autocomplete_list'>";
    var end="</ul>";

    var str="",poi="",keyword="",name="";
    str+=start;
    for(var i= 0,l=items.length;i<l;i++){
        var item=items[i];
        poi=item.poi||"";
        keyword=item.focus||"";
        var reg=new RegExp(keyword,"gi");
        name= item.name.replace(reg,"<mark>"+keyword+"</mark>");
        reg=null;
        str+="<li  data-poi='"+poi+"' data-keyword='"+keyword+"'><span>"+name+"</span></li>";
    }
    return str+end;
});

Handlebars.registerHelper("inc", function(value, options)
{
    return parseInt(value) + 1;
});